### Home Classes Methods

### In Files

- lib/github_api/arguments.rb

### Parent

Object

### Methods

- ::new
- #assert_required
- #assert_values
- #parse
- #sift

### Included Modules

- Github::Normalizer
- Github::ParameterFilter
- Github::Validations

### Class/Module Index

Quicksearch

- Github
- Github::API
- Github::Activity
- Github::Activity::Events
- Github::Activity::Notifications
- Github::Activity::Starring
- Github::Activity::Watching
- Github::ApiFactory
- Github::Arguments
- Github::Authorization
- Github::Authorizations
- Github::AutoloadHelper
- Github::Client
- Github::Configuration
- Github::Connection
- Github::Constants
- Github::CoreExt
- Github::CoreExt::OrderedHash
- Github::Descendants
- Github::Emojis
- Github::Error
- Github::Error::BadRequest
- Github::Error::ClientError
- Github::Error::Forbidden
- Github::Error::GithubError
- Github::Error::InternalServerError
- Github::Error::InvalidOptions
- Github::Error::NotAcceptable
- Github::Error::NotFound
- Github::Error::RequiredParams
- Github::Error::ServiceError
- Github::Error::ServiceUnavailable
- Github::Error::Unauthorized
- Github::Error::UnknownValue
- Github::Error::UnprocessableEntity
- Github::Error::Validations
- Github::Gists
- Github::Gists::Comments
- Github::GitData
- Github::GitData::Blobs
- Github::GitData::Commits
- Github::GitData::References
- Github::GitData::Tags
- Github::GitData::Trees
- Github::Gitignore
- Github::Issues
- Github::Issues::Assignees
- Github::Issues::Comments
- Github::Issues::Events
- Github::Issues::Labels
- Github::Issues::Milestones
- Github::Jsonable
- Github::Markdown
- Github::Meta
- Github::MimeType
- Github::Normalizer
- Github::Orgs
- Github::Orgs::Members
- Github::Orgs::Teams
- Github::PageIterator
- Github::PageLinks
- Github::PagedRequest
- Github::Pagination
- Github::ParameterFilter
- Github::ParamsHash
- Github::PullRequests
- Github::PullRequests::Comments
- Github::RateLimit
- Github::Repos
- Github::Repos::Collaborators
- Github::Repos::Comments
- Github::Repos::Commits
- Github::Repos::Contents
- Github::Repos::Downloads
- Github::Repos::Forks
- Github::Repos::Hooks
- Github::Repos::Keys
- Github::Repos::Merging
- Github::Repos::PubSubHubbub
- Github::Repos::Statistics
- Github::Repos::Statuses
- Github::Request
- Github::Request::BasicAuth
- Github::Request::Jsonize
- Github::Request::OAuth2
- Github::Resource
- Github::Response
- Github::Response::Header
- Github::Response::Jsonize
- Github::Response::Mashify
- Github::Response::RaiseError
- Github::Response::Xmlize
- Github::ResponseWrapper
- Github::S3Uploader
- Github::Say
- Github::Scopes
- Github::Search
- Github::Users
- Github::Users::Emails
- Github::Users::Followers
- Github::Users::Keys
- Github::Utils
- Github::Utils::Url
- Github::VERSION
- Github::Validations
- Github::Validations::Format
- Github::Validations::Presence
- Github::Validations::Required
- Github::Validations::Token
- Hash

No matching classes.

# Github::Arguments

Request arguments handler

### Constants

AUTO_PAGINATION

### Attributes

api[R]

The request api

params[R]

Parameters passed to request

remaining[R]

### Public Class Methods

new(api, options={}) click to toggle source

Takes api, filters and required arguments

# Parameters

    :required - arguments that must be present before request is fired

    # File lib/github_api/arguments.rb, line 36
    def initialize(api, options={})
      normalize! options
      @api      = api
      @required = options.fetch('required', []).map(&:to_s)
      @optional = options.fetch('optional', []).map(&:to_s)
    end

### Public Instance Methods

assert_required(required) click to toggle source

Check if required keys are present inside parameters hash.

    # File lib/github_api/arguments.rb, line 75
    def assert_required(required)
      assert_required_keys required, params
      self
    end

assert_values(values, key=nil) click to toggle source

Check if parameters match expected values.

    # File lib/github_api/arguments.rb, line 82
    def assert_values(values, key=nil)
      assert_valid_values values, (key.nil? ? params : params[key])
      self
    end

parse(*args, &block) click to toggle source

Parse arguments to allow for flexible api calls. Arguments can be part of parameters hash or be simple string arguments.

    # File lib/github_api/arguments.rb, line 46
    def parse(*args, &block)
      options = ParamsHash.new(args.extract_options!)
      normalize! options

      if !args.size.zero?
        parse_arguments *args
      else
        # Arguments are inside the parameters hash
        parse_options options
      end
      @params = options
      @remaining = extract_remaining(args)
      extract_pagination(options)
      yield_or_eval(&block)
      self
    end

sift(keys, key=nil, options={}) click to toggle source

Remove unkown keys from parameters hash.

# Parameters

    :recursive - boolean that toggles whether nested filtering should be applied

    # File lib/github_api/arguments.rb, line 68
    def sift(keys, key=nil, options={})
      filter! keys, (key.nil? ? params : params[key]), options if keys.any?
      self
    end

[Validate]

Generated with the Darkfish Rdoc Generator 2.